[HDU

来源:互联网 发布:新闻稿用什么软件 编辑:程序博客网 时间:2024/06/05 20:26

Link:http://acm.hdu.edu.cn/showproblem.php?pid=1069

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,representing the number of different blocks in the following data set. The maximum value for n is 30.Each of the next n lines contains three integers representing the values xi, yi and zi.Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

110 20 3026 8 105 5 571 1 12 2 23 3 34 4 45 5 56 6 67 7 7531 41 5926 53 5897 93 2384 62 6433 83 270

Sample Output

Case 1: maximum height = 40Case 2: maximum height = 21Case 3: maximum height = 28Case 4: maximum height = 342

思路:

给出一定的长宽高 x, y, z,那么长方体摆放的方法就有6种1.  x  y  z2.  x  z  y3.  y  x  z4.  y  z  x5.  z  x  y6.  z  y  x那么思路如下:1. 定义一个结构体函数, 输入x  y  z 时存入六种不同的摆放方式2. 排序:x y 大的排在前面  z因为是高 不用考虑3. 动态规划:dp[i]存长方体的高,dp[i]=brick[i].z    满足条件 brick[j].x > brick[i].x && brick[j].y > brick[i].y 时    动态方程为 dp[i]=max(dp[i],dp[j]+brick[i].z

Code:

#include<cstdio>#include<cstdlib>#include<cstring>#include<cmath>#include<algorithm>#include<iostream>#include<queue>#include<stack>using namespace std;int cnt;int dp[200];struct Brick{    int x,y,z;}brick[200];void UpDate(int x,int y,int z){    brick[cnt].x=x;    brick[cnt].y=y;    brick[cnt++].z=z;    brick[cnt].x=x;    brick[cnt].y=z;    brick[cnt++].z=y;    brick[cnt].x=y;    brick[cnt].y=x;    brick[cnt++].z=z;    brick[cnt].x=y;    brick[cnt].y=z;    brick[cnt++].z=x;    brick[cnt].x=z;    brick[cnt].y=x;    brick[cnt++].z=y;    brick[cnt].x=z;    brick[cnt].y=y;    brick[cnt++].z=x;}bool cmp(Brick a,Brick b){    if(a.x==b.x)        return a.y>b.y;    return a.x>b.x;}int main(){    int n,c=1,x,y,z;    while(~scanf("%d",&n),n)    {        cnt=1;        int ans=0;        for(int i=1;i<=n;i++)        {            scanf("%d%d%d",&x,&y,&z);            UpDate(x,y,z);        }        cnt--;        sort(brick+1,brick+cnt+1,cmp);        for(int i=1;i<=cnt;i++)        {            dp[i]=brick[i].z;            for(int j=1;j<i;j++)            {                if(brick[j].x>brick[i].x&&brick[j].y>brick[i].y)                    dp[i]=max(dp[i],dp[j]+brick[i].z);                ans=max(ans,dp[i]);            }        }        printf("Case %d: maximum height = %d\n",c++,ans);    }return 0;}
原创粉丝点击